.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "1.00",
.\"     date            = "21 April 1999",
.\"     time            = "15:46:49 MDT",
.\"     filename        = "awkpretty.man",
.\"     address         = "Center for Scientific Computing
.\"                        University of Utah
.\"                        Department of Mathematics, 322 INSCC
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 585 1640, +1 801 581 4148",
.\"     URL             = "http://www.math.utah.edu/~beebe",
.\"     checksum        = "04980 546 1899 13520",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@ieee.org (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "awk, prettyprinter",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual pages
.\"                        for awkpretty, a utility for prettyprinting
.\"                        awk programs.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.TH AWKPRETTY 1 "21 April 1999" "Version 1.00"
.\"=====================================================================
.SH NAME
awkpretty \- prettyprint awk programs
.\"=====================================================================
.SH SYNOPSIS
.B awkpretty
[
.B \-?
]
[
.B \-a
]
[
.B \-b
]
[
.BI \-c " nnn"
]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.BI \-f " awk-program-file"
]
[
.B \-g
]
[
.B \-h
]
[
.BI \-i " nnn"
]
.if n .ti +\w'\fBawkpretty\fP 'u
.\"[
.\".B \-p
.\"]
[
.B \-q
]
[
.B \-r
]
.if t .ti +\w'\fBawkpretty\fP 'u
[
.B \-s
]
[
.B \-v
]
[
.BI \-w " nnn"
]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.BI \-x " nnn"
]
[
.BI \-y " str"
]
[
.BI \-z " str"
]
.if n .ti +\w'\fBawkpretty\fP 'u
.if t .ti +\w'\fBawkpretty\fP 'u
[
awk-program-file(s)
]
.I "> new-awk-program-file"
.PP
or
.PP
.B awkpretty
[
.B \-\-?
]
[
.BI \-\-action-column " nnn"
]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.BI \-\-action-separator " str"
]
[
.B \-\-awklex-input
]
.if n .ti +\w'\fBawkpretty\fP 'u
.if t .ti +\w'\fBawkpretty\fP 'u
[
.B \-\-blanks-only
]
[
.BI \-\-comment-column " nnn"
]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.BI \-\-file " awk-program-file"
]
.if n .ti +\w'\fBawkpretty\fP 'u
.if t .ti +\w'\fBawkpretty\fP 'u
[
.BI \-\-function-separator " str"
]
[
.B \-\-globals
]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.B \-\-help
]
[
.BI \-\-indent " nnn"
]
.if t .ti +\w'\fBawkpretty\fP 'u
.\"[
.\".B \-\-purge-semicolons
.\"]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.B \-\-quick
]
[
.B \-\-reorder-functions
]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.B \-\-standard-comments
]
.if t .ti +\w'\fBawkpretty\fP 'u
[
.BI \-\-version
]
.if n .ti +\w'\fBawkpretty\fP 'u
[
.BI \-\-width " nnn"
]
.if n .ti +\w'\fBawkpretty\fP 'u
.if t .ti +\w'\fBawkpretty\fP 'u
[
awk-program-file(s)
]
.I "> new-awk-program-file"
.\"=====================================================================
.SH DESCRIPTION
.B awkpretty
is a prettyprinter for
.BR awk (1)
programs.
.PP
It uses
.BR awklex (1)
to obtain a lexical token stream derived from a
grammatical analysis of the input file(s), and
then outputs that stream as an
.BR awk (1)
program with standardized spacing and line breaks,
generally improving readability.
.\"=====================================================================
.SH OPTIONS
.B awkpretty
accepts two styles of options: the old, concise,
but possibly, inscrutable, UNIX hyphen-letter
pairs, and longer GNU/POSIX-style options
beginning with two hyphens.  The GNU/POSIX-style
options can be always abbreviated to any unique
leading prefix, and the two styles can be used
interchangeably.
.PP
Options that take a value expect it as a
.I separate
following command-line argument: use \fC\-w 72\fP,
.I not
\&\fC\-w72\fP.
.\"--------------------------------------------------
.TP \w'\-\-comment-columnMnnn'u+2n
.BI \-x " nnn"
.TP
.BI \-\-action-column " nnn"
For the part of the input
.BR awk (1)
program corresponding to
.I "pattern {action}"
pairs, where
.I pattern
may be empty, indent the
.I {action}
part to begin after column
.IR nnn .
.IP
[Default: 16]
.\"--------------------------------------------------
.TP
.BI \-y " str"
.TP
.BI \-\-action-separator " str"
Normally,
.B awkpretty
separates
.I "pattern {action}"
sections by two blank lines, to help set them off
from one another.  This option can be used to
provide an alternate separator string, which must
consist exclusively of comments and/or whitespace.
Newlines in the string must be represented by
\fC\en\fP, and spaces by \fC\es\fP.
.IP
[Default: \fC"\en\en\en"\fP]
.\"--------------------------------------------------
.TP
.B \-a
.TP
.B \-\-awklex-input
Input is not
.B awk
program text, but rather, a lexical token stream
from
.BR awklex (1).
.IP
This option is provided for the convenience of
other tools that themselves process, or produce,
lexical token streams, allowing them to use
.B awkpretty
as a backend filter to reconstruct
.B awk
program text.
.IP
[Default: Input is
.B awk
program text]
.\"--------------------------------------------------
.TP
.B \-b
.TP
.B \-\-blanks-only
Use only blanks to provide needed whitespace in
the output.
.IP
[Default: use horizontal tabs and blanks, because
that is shorter, and also more likely to preserve
the intended text alignment when minor edits are
made]
.\"--------------------------------------------------
.TP
.BI \-c " nnn"
.TP
.BI \-\-comment-column " nnn"
Set the comment column to
.IR nnn .
Inline comments will then be lined up to start
immediately after that column, unless the line is
too long, in which case, they are moved to an
otherwise empty following line.
.IP
A zero value suppresses columnar alignment: inline
comments will be prefixed by only a single tab.
.IP
[Default: 40]
.\"--------------------------------------------------
.TP
.BI \-f " awk-program-file"
.TP
.BI \-\-file " awk-program-file"
Specify the name of the file containing the
.BR awk (1)
program.
.IP
Multiple
.B \-f
options can be used, if required; their files are
then treated as if logically concatenated in the
order that they were specified.
.IP
The filename can be a hyphen, \-, meaning that
input should be taken from
.IR stdin ,
allowing
.B awkpretty
to be used in the middle of a command pipeline.
.\"--------------------------------------------------
.TP
.BI \-z " str"
.TP
.BI \-\-function-separator " str"
Normally,
.B awkpretty
separates output function definitions by two blank
lines, to help set them off from one another.
This option can be used to provide an alternate
separator string, which must consist exclusively
of comments and/or whitespace.  Newlines in the
string must be represented by \fC\en\fP, and spaces
by \fC\es\fP.
.IP
[Default: \fC"\en\en\en"\fP]
.\"--------------------------------------------------
.TP
.B \-g
.TP
.B \-\-globals
Produce on
.I stderr
a sorted listing of function names and global
variables that they reference, one such pair per
line.
.IP
Because the
.B awk
programming language does not have variable
declarations, function-local variables are
conventionally created by declaring them as
additional arguments, unused by callers.  Failure
to do so can result in a nasty bug when an
assignment to a supposedly local variable in a
function silently modifies a global variable.
This option provides a way to detect such errors.
.IP
[Default: no list of global variables]
.\"--------------------------------------------------
.TP
.BI \-?
.TP
.BI \-h
.TP
.BI \-\-?
.TP
.BI \-\-help
Print a brief help message, and exit immediately
with a success status code.
.\"--------------------------------------------------
.TP
.BI \-i " nnn"
.TP
.BI \-\-indent " nnn"
Set the statement level indentation increment to
.IR nnn .
Each logical increase in statement nesting
increases leading indentation by that amount.
.IP
Values outside the range 0 .\|.\|. 8 will be reset
to the nearer endpoint of that range.
.IP
The choice between tabs-and-blanks, or just
blanks, for the leading indentation depends on
whether
.B \-\-blanks-only
was specified or not.
.IP
[Default: 4]
.\"--------------------------------------------------
.\".TP
.\".B \-p
.\".TP
.\".B \-\-purge-semicolons
.\"Remove unneeded semicolons at ends of line.
.\".IP
.\"Although the
.\".BR awk (1)
.\"programming language allows semicolons to separate
.\"statements, line breaks do as well, and are more
.\"conventional.  C and C++ programmers who write
.\".BR awk (1)
.\"programs may out of habit put in unneeded
.\"statement-ending semicolons that this option can
.\"safely remove.
.\".IP
.\"[Default: preserve semicolons]
.\"--------------------------------------------------
.TP
.B \-q
.TP
.B \-\-quick
Suppress reading of the user initialization file,
.IR $HOME/.awkprettyrc .
Normally, the contents of that file, if it exists,
are implicitly inserted at the beginning the
command line, with comments removed and newlines
replaced by spaces.  Thus, that file can contain
any
.B awkpretty
options defined in this documentation, either one
option, or option/value pair, per line, or with
multiple options per line.  Empty lines, and lines
that begin with optional whitespace followed by a
sharp (#) are comment lines that are discarded.
.IP
If the initialization file contains backslashes,
they must be doubled because the text is
interpreted by the shell before
.B awkpretty
sees it.
.\"--------------------------------------------------
.TP
.B \-r
.TP
.B \-\-reorder-functions
Sort functions into alphabetical order, ignoring
lettercase.
.IP
In large programs, there is rarely any reason to
use any order of function definition other than
alphabetical, because that is the only order that
other human readers are sure to understand.
.IP
[Default: leave functions in their original order]
.\"--------------------------------------------------
.TP
.B \-s
.TP
.B \-\-standard-comments
Normally,
.B awkpretty
treats comments in one of two ways: if they begin
a line, their indentation is preserved.
Otherwise, they are indented to a comment column
which is settable by the
.B \-\-comment-column
option.
.IP
However, with this option,
.B awkpretty
converts comments to a style found useful by
decades of practice in LISP programming: three or
more leading comment start characters (###) mean
that the comment must be flush left; doubled
start characters (##) mean that the comment must
be aligned at the current statement indentation; a
single start character (#) means that the comment
should be aligned at the default comment column.
.IP
Comments that do not conform to these start
character conventions are modified as follows.
Comments that are found at beginning of line are
untabified, then adjusted to begin with three
start characters (###).  Comments found indented
are untabified, and adjusted to begin with two
such characters (##).  All other comments (those
following non-blank tokens) are adjusted to begin
with a single start character (#).  The comment is
then output according to the conventions described
in the previous paragraph.
.IP
[Default: leave comments unmodified, though
possibly changed in indentation]
.\"--------------------------------------------------
.TP
.BI \-v
.TP
.BI \-\-version
Print the program version number, and exit
immediately with a success status code.
.\"--------------------------------------------------
.TP
.BI \-w " nnn"
.TP
.BI \-\-width " nnn"
Set the preferred maximum output line width to
.IR nnn .
Lines with excessively long tokens may extend
beyond this limit, since long tokens, such as
complete comment strings, are never broken at line
boundaries.
.IP
A zero value of
.I nnn
is treated as `infinity', effectively preserving
line breaks from the input file.
.IP
[Default: 80]
.\"=====================================================================
.SH FILES
.TP
\&\fC$HOME/.awkprettyrc\fP
User initialization file containing customized
.B awkpretty
command-line options.
.TP
\&\fC@LIBDIR@/awkpretty.awk\fP
.BR awk (1)
program
invoked by
.B awkpretty
to filter the output of
.BR awklex (1),
and produce a prettyprinted program on
.IR stdout .
.\"=====================================================================
.SH "SEE ALSO"
.BR awk (1),
.BR awklex (1),
.BR awkunlex (1),
.BR gawk (1),
.BR mawk (1),
.BR nawk (1).
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe
Center for Scientific Computing
University of Utah
Department of Mathematics, 322 INSCC
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP, \fCbeebe@ieee.org\fP
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
Telephone: +1 801 581 5254
FAX: +1 801 585 1640, +1 801 581 4148
.fi
.\"=====================================================================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
