.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "1.00",
.\"     date            = "29 March 1999",
.\"     time            = "19:05:35 MST",
.\"     filename        = "awkunlex.man",
.\"     address         = "Center for Scientific Computing
.\"                        University of Utah
.\"                        Department of Mathematics, 322 INSCC
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 585 1640, +1 801 581 4148",
.\"     URL             = "http://www.math.utah.edu/~beebe",
.\"     checksum        = "64092 195 677 5339",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@ieee.org (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "awk, lexer, lexical analyzer, unlexer",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual pages
.\"                        for awkunlex, a utility for recombining
.\"                        a lexical token stream from awklex back
.\"                        into an awk program.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.TH AWKUNLEX 1 "29 March 1999" "Version 1.00"
.\"======================================================================
.SH NAME
awkunlex \- recombine an awk lexical token stream into an awk program
.\"=====================================================================
.SH SYNOPSIS
.B awkunlex
[
.B \-?
]
[
.BI \-f " file"
]
[
.B \-h
]
[
.B \-v
]
.if n .ti +\w'\fBawkunlex\fP 'u
[
.I file(s)
]
.I "> awk-program-file"
.nf
or
.fi
.B awkunlex
[
.B \-\-?
]
[
.BI \-\-file " file"
]
[
.B \-\-help
]
[
.BI \-\-version
]
.if n .ti +\w'\fBawkunlex\fP 'u
[
.I file(s)
]
.I "> awk-program-file"
.\"=====================================================================
.SH DESCRIPTION
.B awkunlex
converts a lexical token stream from
.BR awklex (1)
back into an
.BR awk (1)
program, substantially preserving the original
text layout.
.PP
Input comes from the file(s) specified on the
command line, or the file in the
.B \-f
option, or else, if no file is given, from
.IR stdin .
Output is written to
.IR stdout .
.\"=====================================================================
.SH OPTIONS
.B awkunlex
accepts two styles of options: the old, concise,
but possibly, inscrutable, UNIX hyphen-letter
pairs, and longer GNU/POSIX-style options
beginning with two hyphens.  The GNU/POSIX-style
options can be always abbreviated to any unique
leading prefix, and the two styles can be used
interchangeably.
.\"--------------------------------------------------
.TP \w'\fB\-\-file\fPM\fIawk-program-file\fP'u+2n
.BI \-f " awk-program-file"
.TP
.BI \-\-file " awk-program-file"
Specify the name of the
.BR awk (1)
program file.
.IP
Multiple
.B \-f
options can be used, if required; their files are
then treated as a logical concatenation, in the
order that they were specified.
.IP
The filename can be a hyphen, \-, meaning that
input should be taken from
.IR stdin ,
allowing
.B awkunlex
to be used in the middle of a command pipeline.
.IP
This option is included solely for similarity to
the command line expected by
.BR awk (1);
for
.BR awkunlex ,
the filenames alone are sufficient.
.\"--------------------------------------------------
.TP
.BI \-?
.TP
.BI \-h
.TP
.BI \-\-?
.TP
.BI \-\-help
Print a brief help message, and exit immediately
with a success status code.
.\"--------------------------------------------------
.TP
.BI \-v
.TP
.BI \-\-version
Print the program version number, and exit
immediately with a success status code.
.\"=====================================================================
.SH FILES
.TP
\&\fC@LIBDIR@/awkpretty.awk\fP
Prettyprinter backend
.BR awk (1)
program invoked by
.B awkunlex
to filter the output of
.BR awklex (1),
and produce a prettyprinted
.BR awk (1)
program on
.IR stdout .
.\"=====================================================================
.SH "SEE ALSO"
.BR awk (1),
.BR awkpretty (1),
.BR awklex (1),
.BR gawk (1),
.BR mawk (1),
.BR nawk (1).
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe
Center for Scientific Computing
University of Utah
Department of Mathematics, 322 INSCC
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP, \fCbeebe@ieee.org\fP
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
Telephone: +1 801 581 5254
FAX: +1 801 585 1640, +1 801 581 4148
.fi
.\"=====================================================================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
