#! /bin/sh
# Given one or more checknnn.in files, create checknnn.lok and
# checknnn.ok files for the baseline of a test.
#
# Usage:
#	./newcheck.sh file1.in file2.in file3.in ...
#
# [26-Mar-1999]

### This value is set at configure time in the output awkpretty.sh file:
AWK=/opt/archive/bin/gawk

for f in $@
do
	g=`basename $f .in`
	echo ===== $g
	chmod 666 $g.lok $g.pok 2>/dev/null
	rm -f $g.lok $g.pok $g.uok 2>/dev/null
	./awklex -f $f > $g.lok
	./awkunlex.sh $g.lok >$g.uok
	if test -f $g.opt ; then true ; else touch $g.opt ; fi
	./awkpretty.sh --awklex-input `cat $g.opt` $g.lok > $g.pok
	chmod 444 $g.in $g.lok $g.pok $g.uok
done
